/*
 * Copyright (c) 2001-2007
 *     DecisionSoft Limited. All rights reserved.
 * Copyright (c) 2004-2007
 *     Oracle. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * $Id: ClosureResult.hpp,v 1.2 2007/11/28 13:13:25 jpcs Exp $
 */

#ifndef _CLOSURERESULT_HPP
#define _CLOSURERESULT_HPP

#include <xqilla/runtime/Result.hpp>
#include <xqilla/context/impl/VarStoreImpl.hpp>

class VariableStore;
class ASTNode;

class XQILLA_API ClosureResult : public ResultImpl
{
public:
  ClosureResult(const ASTNode *ast, DynamicContext *context, const VariableStore *varStore = 0);

  virtual Item::Ptr next(DynamicContext *context);

  virtual std::string asString(DynamicContext *context, int indent) const { return ""; }

private:
  VarStoreImpl varStore_;
  Result result_;
};

#endif
